unit DctMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.ExtCtrls, Vcl.StdCtrls, System.Math;

type
  D2array = array of array of Double;
  B2array = array of array of Byte;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    DCT2Btn: TButton;
    INVBtn: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure DCT2BtnClick(Sender: TObject);
    procedure INVBtnClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure DCT(var real: D2array; inv: boolean);
    procedure DST(var real: D2array; inv: boolean);
    procedure DCT2Disp(real: D2array);
    procedure INVfilter(real: D2array);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 384;    // \gTCY

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  X_SIZE        : Integer;                    // ̓f[^[摜
  Y_SIZE        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C
  GrayMat       : B2array;                    // O[pz
  OutDMat       : B2array;                    // 摜o͗pz
  real          : D2array;
const
  kr  = 0.299;                     // R PxϊW
  kg  = 0.587;                     // G PxϊW
  kb  = 0.114;                     // B PxϊW


// Sinϊ
// inv False ϊ True tϊ
procedure TForm1.DST(var real: D2array; inv: boolean);
var
  M2                : Double;
  norm              : Double;
  Tre               : D2array;
  WrTable           : D2array;
  HrTable           : D2array;
  i, j, y, x, xx, yy: Integer;
begin
  // Ɨpzm
  SetLength(Tre, X_SIZE, Y_SIZE);
  SetLength(WrTable, X_SIZE, X_SIZE);
  SetLength(HrTable, Y_SIZE, Y_SIZE);

  // XDST
  M2 :=   PI / X_SIZE;
  norm := sqrt(2.0 / X_SIZE);
  // ϊsine[u AႢg ق֐ݒ
  for i := 0 to X_SIZE - 1 do
    for j := 0 to X_SIZE - 1 do
      if inv then Wrtable[i][j] := sin(M2 * (i + 0.5) * j)
             else Wrtable[i][j] := sin(M2 * (j + 0.5) * i);
  // yɕϊ
  for y := 0 to Y_SIZE - 1 do
    // ꎟDST
    for x := 0 to X_SIZE - 1 do begin
      Tre[x][y] := 0.0;
      for xx := 0 to X_SIZE - 1 do
        Tre[x][y] := Tre[x][y] + real[xx][y] * Wrtable[x][xx];
      Tre[x][y] := Tre[x][y] * norm;
    end;

  // YDST
  M2 :=   PI / Y_SIZE;
  norm := sqrt(2.0 / Y_SIZE);
  // ϊsine[u AႢg ق֐ݒ
  for i := 0 to  Y_SIZE - 1 do
    for j := 0 to Y_SIZE - 1 do
      if inv then Hrtable[i][j] := sin(M2 * (i + 0.5) * j)
             else Hrtable[i][j] := sin(M2 * (j + 0.5) * i);
  // Xɕϊ
  for x := 0 to X_SIZE - 1 do
    // ꎟDST
    for y := 0 to Y_SIZE - 1 do begin
      real[x][y] := 0.0;
      for yy := 0 to Y_SIZE - 1 do
        real[x][y]  := real[x][y] + Tre[x][yy] * Hrtable[y][yy];
      real[x][y] := real[x][y]  * norm;
    end;
end;

// Cosϊ
// inv False ϊ True tϊ
procedure TForm1.DCT(var real: D2array; inv: boolean);
var
  M2                : Double;
  norm              : Double;
  startX            : integer;
  Tre               : D2array;
  WrTable           : D2array;
  HrTable           : D2array;
  i, j, y, x, xx, yy: Integer;
begin
  // Ɨpzm
  SetLength(Tre, X_SIZE, Y_SIZE);
  SetLength(WrTable, X_SIZE, X_SIZE);
  SetLength(HrTable, Y_SIZE, Y_SIZE);

  // XDCT
  M2 :=   PI / X_SIZE;
  norm := 1;
  startX := 0;
  if inv then begin
    norm := 2.0 / X_SIZE;
    startX := 1;
  end;
  // ϊe[u AႢg ق֐ݒ
  for i := 0 to X_SIZE - 1 do
    for j := startx to X_SIZE - 1 do begin
      if inv then Wrtable[i][j] := cos(M2 * (i + 0.5) * j)
             else Wrtable[i][j] := cos(M2 * (j + 0.5) * i);
//  ϊe[uvZ͉Lł̈׊ZȂĂ܂
//      if inv then Wrtable[i][j] := cos(pi * j / 2 / X_SIZE * (2 * i + 1))
//             else Wrtable[i][j] := cos(pi * i / 2 / X_SIZE * (2 * j + 1));
    end;
  // yɕϊ
  for y := 0 to Y_SIZE - 1 do
    // ꎟDCT
    for x := 0 to X_SIZE - 1 do begin
      Tre[x][y] := 0.0;
      for xx := startx to X_SIZE - 1 do
        Tre[x][y] := Tre[x][y] + real[xx][y] * Wrtable[x][xx];
      if inv then Tre[x][y] := Tre[x][y] + real[0][y] * 0.5;    // 
      Tre[x][y] := Tre[x][y] * norm;
    end;

  // YDCT
  M2 :=   PI / Y_SIZE;
  if inv then norm := 2.0 / Y_SIZE;
  // ϊe[u AႢg ق֐ݒ
  for i := 0 to  Y_SIZE - 1 do
    for j := startx to Y_SIZE - 1 do begin
      if inv then Hrtable[i][j] := cos(M2 * (i + 0.5) * j)
             else Hrtable[i][j] := cos(M2 * (j + 0.5) * i);
//  ϊe[uvZ͉Lł̈׊ZȂĂ܂
//      if inv then Hrtable[i][j] := cos(pi * j / 2 / Y_SIZE * (2 * i + 1))
//             else Hrtable[i][j] := cos(pi * i / 2 / Y_SIZE * (2 * j + 1));
    end;
  // Xɕϊ
  for x := 0 to X_SIZE - 1 do
    // ꎟDCT
    for y := 0 to Y_SIZE - 1 do begin
      real[x][y] := 0.0;
      for yy := startx to Y_SIZE - 1 do
        real[x][y] := real[x][y] + Tre[x][yy] * Hrtable[y][yy];
      if inv then real[x][y] := real[x][y] + Tre[x][0] * 0.5;   // 
      real[x][y] := real[x][y]  * norm;
    end;
end;

// p[XyNgi̓Aΐɂ܂j
// ΐϊ͍FɂȂ̂h~邽߂ł
procedure TForm1.DCT2Disp(real: D2array);
var
  spec      : D2array;
  Max       : Double;
  x, y      : Integer;
  col       : Integer;
  norm      : Double;
  knorm     : Double;
begin
  SetLength(spec, X_SIZE, Y_SIZE);
  max := 0;
  if CheckBox2.Checked then knorm := 1                            // DST
                       else knorm := 4 / (X_SIZE * Y_SIZE);       // DCT
  for x := 0 to X_SIZE - 1 do
    for y := 0 to Y_SIZE - 1 do begin
      // p[XyNgɕϊ
      norm := real[x][y] * real[x][y] * knorm;
      if norm <> 0 then norm := ln(norm);     // g摜\̈בΐϊ
      spec[x][y] := norm;                     // Pȉ͑ΐŕƂȂ׎̉摜ϊ0ƂȂ܂
      if norm > max then max := norm;         // ől
    end;

// 摜f[^ɏ
  for x := 0 to X_SIZE - 1 do
    for y := 0 to Y_SIZE - 1 do begin
      col := round(spec[x][y] / max * 255);   // ől255ɕϊ
      if col > 255 then col := 255;
      if col < 0   then col := 0;
      OutDMat[y, x] := col;
    end;
end;

// DCT, DST I
procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then CheckBox1.Enabled := False
                       else CheckBox1.Enabled := True;
end;

// p[XyNg摜\
procedure TForm1.DCT2BtnClick(Sender: TObject);
var
  x, y        : Integer;
  PBA         : PBytearray;
  WP          : integer;
  r           : double;
  Flow, Fhigh : double;
  r00Back     : double;
begin
  val(LabeledEdit1.Text, Flow, x);
  if (x <> 0) or (Flow < 0) then begin
    application.MessageBox('Ⴂ̎gɊԈႢ܂B','', 0);
    exit;
  end;
  val(LabeledEdit2.Text, Fhigh, x);
  if (x <> 0) or (Fhigh < 0) then begin
    application.MessageBox('̎gɊԈႢ܂B','', 0);
    exit;
  end;
  if Flow >= Fhigh then begin
    application.MessageBox('ƒႢ̒ltłB','', 0);
    exit;
  end;
  // g[()̐ݒ
  DCT2Btn.Enabled := False;
  SetLength(real, X_SIZE, Y_SIZE);
  // 摜f[^[zɃZbg
  for x := 0 to X_SIZE - 1 do
    for y := 0 to Y_SIZE - 1 do
      real[x, y] := GrayMat[y][x];
  // XyNg
  if CheckBox2.Checked then DST(real, False)
                       else DCT(real, False);
  // gtB^[̎{@g͈͊OOɃZbg
  r00Back := real[0, 0];
  if CheckBox1.Checked and not CheckBox2.Checked then real[0, 0] := 0;
  for x := 0 to X_SIZE - 1 do
    for y := 0 to Y_SIZE - 1 do begin
      r := sqrt(x * x + y * y);
      if r < Flow  then real[x, y] := 0;
      if r > Fhigh then real[x, y] := 0;
    end;
  if not CheckBox1.Checked and not CheckBox2.Checked then real[0, 0] := r00Back;
  DCT2Disp(real);                  // ʕ\pɕϊ
  for Y := 0 to Y_SIZE - 1 do begin
    PBA := OutputBitmap.ScanLine[Y];
    for X := 0 to X_SIZE - 1 do begin
      WP := X * 3;
      PBA[WP]     := OutDMat[Y, X];
      PBA[WP + 1] := OutDMat[Y, X];
      PBA[WP + 2] := OutDMat[Y, X];
    end;
  end;
  Image1.Canvas.StretchDraw(VRect, OutputBitmap);     // o͘gɕϔ{o
  DCT2Btn.Enabled := True;
  INVBtn.Enabled := True;
end;

// tϊ摜\
procedure TForm1.INVfilter(real: D2array);
var
  x, y    : Integer;
  data    : Integer;
begin
  if CheckBox2.Checked then DST(real, true)             // tϊ
                       else DCT(real, true);
  for x := 0 to X_SIZE - 1 do
    for y := 0 to Y_SIZE - 1 do begin
      data := round(real[x, y]);
      if data > 255 then data := 255;
      if data < 0   then data := 0;
      OutDMat[y, x] := data;
    end;
end;

// tϊ\
procedure TForm1.INVBtnClick(Sender: TObject);
var
  x, y        : Integer;
  PBA         : PBytearray;
  WP          : integer;
begin
  INVBtn.Enabled := False;
  INVfilter(real);
  // tϊ摜\
  for y := 0 to Y_SIZE - 1 do begin
    PBA := OutputBitmap.ScanLine[Y];
    for x := 0 to X_SIZE - 1 do begin
      WP := X * 3;
      PBA[WP]     := OutDMat[y, x];
      PBA[WP + 1] := OutDMat[y, x];
      PBA[WP + 2] := OutDMat[y, x];
    end;
  end;
  Image1.Canvas.StretchDraw(VRect, OutputBitmap);    // o͘gɕϔ{o
end;

// t@C̃I[vyыPxϊ
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  IHeight     : Integer;
  IWidth      : Integer;
  X, Y        : Integer;
  PBA         : PBytearray;
  PFD, WP     : Integer;
begin
  INVBtn.Enabled := False;
  DCT2Btn.Enabled := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        Y_SIZE  := WIC.Height;                                // 摜擾
        X_SIZE  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if Y_SIZE <= X_SIZE then                              // cɂo̓TCYݒ
          IHeight := Round(IWidth * Y_SIZE / X_SIZE)
        else
          IWidth := Round(IHeight * X_SIZE / Y_SIZE);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
//        Image1.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InputDBitmap.Assign(WIC);                             // Tbitmap  TWICImageRs[
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  OutputBitmap.Width  := X_SIZE;
  OutputBitmap.Height := Y_SIZE;
  setLength(GrayMat, Y_SIZE, X_SIZE);
  setLength(OutDMat, Y_SIZE, X_SIZE);
  PFD := 3;
  if InputDBitmap.PixelFormat = pf32bit then PFD := 4;
  for Y := 0 to Y_SIZE - 1 do begin
    PBA := InputDBitmap.ScanLine[Y];
    for X := 0 to X_SIZE - 1 do begin
      WP := X * PFD;
      GrayMat[Y][X] := Round(PBA[WP] * kb + PBA[WP + 1] * kg + PBA[WP + 2] * kr); // Pxf[^[ɕϊ
    end;
  end;
  for Y := 0 to Y_SIZE - 1 do begin
    PBA := OutputBitmap.ScanLine[Y];
    for X := 0 to X_SIZE - 1 do begin
      WP := X * 3;
      PBA[WP]     := GrayMat[Y][X];
      PBA[WP + 1] := GrayMat[Y][X];
      PBA[WP + 2] := GrayMat[Y][X];
    end;
    Image1.Canvas.StretchDraw(VRect, OutputBitmap);           // o͘gɕϔ{o
  end;
  DCT2Btn.Enabled := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  INVBtn.Enabled := False;
  DCT2Btn.Enabled := False;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;

end.
